Subject: bug#46256: [feature/native-comp] AOT eln files ignored if run from build tree

From: Andy Moreton <[email-masked]>
Date: Sat, 06 Mar 2021 00:33:10 +0000

On Thu 04 Mar 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

> Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of
> text editors" <[email-masked]> writes:
>
> [...]
>
>> PS ATM I see a crash too in my 32bit wide-int setup here, this is while
>> executing a top_level_run function loading a .eln file.  I need to
>> compile a more recent gdb to look into this further but it looks
>> something basic is going wrong there.
>
> Ok, I think this issue was that `comp-abi-hash' was not accounting for
> '--with-wide-int' and on my system a wide-int binary was loading a
> non-wide-int .eln.  With 6444f69de2 I added
> `system-configuration-options' as an input to the hash.
>
> This is a conservative choice, we may want to look only at
> '--with-wide-int' but I'm wondering if that's really the only sensitive
> input therefore having `system-configuration-options' in the equation
> looked safer to me at least for now.

I agree that it is a conservative choice, but that still misses features
that are enabled/disabled by default in the configury.

Thus the ABI hash should also include `system-configuration-features'.

    AndyM